"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var rxjs_1 = require("rxjs");
var Controller = /** @class */ (function () {
    function Controller(initialState) {
        this._subject = new rxjs_1.BehaviorSubject(initialState);
    }
    Object.defineProperty(Controller.prototype, "observable", {
        get: function () {
            return this._subject.asObservable();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Controller.prototype, "state", {
        get: function () {
            return this._subject.value;
        },
        enumerable: false,
        configurable: true
    });
    Controller.prototype.emit = function (state) {
        if (this.state === state) {
            return;
        }
        this._subject.next(state);
    };
    Controller.prototype.dispose = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._subject.complete();
                return [2 /*return*/];
            });
        });
    };
    return Controller;
}());
exports.default = Controller;
//# sourceMappingURL=Controller.js.map